var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { jsx as _jsx } from "react/jsx-runtime";
import { lazy, useCallback, useLayoutEffect, useRef, useState, } from 'react';
import { LoaderError } from './error';
import { interopDefault } from './interop-default';
import { WithSuspense } from './with-suspense';
/**
 *
 * @param load   /**
 * Function that must call a dynamic import().\
 * This must return a Promise which resolves to a module with a React component (it could be default export).
 *
 * @example
 *
 * // It has default import
 * () => import('./MyComponent')
 *
 * @example
 *
 * // Directly return a module with a component
 * async () => (await import('./MyComponent')).MyComponent
 *
 * @param options {InteractionLoaderOptions} Interaction loader options.
 */
export function intersectionLoader(load, _a) {
    var _b = _a === void 0 ? {} : _a, intersectionObserverOptions = _b.intersectionObserverOptions, force = _b.force, fallback = _b.fallback, placeholderProps = _b.placeholderProps;
    return function (props) {
        var _this = this;
        var _a;
        var root = useRef(null);
        var _b = __read(useState(), 2), setForceUpdate = _b[1];
        var Component = useRef();
        var loadComponent = useCallback(function () { return __awaiter(_this, void 0, void 0, function () {
            var component, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = interopDefault;
                        return [4 /*yield*/, load()];
                    case 1:
                        component = _a.apply(void 0, [_b.sent()]);
                        if (!component) {
                            setForceUpdate(function () {
                                throw new LoaderError('Component is not defined');
                            });
                            return [2 /*return*/];
                        }
                        Component.current = component;
                        setForceUpdate(function (f) { return !f; });
                        return [2 /*return*/];
                }
            });
        }); }, []);
        useLayoutEffect(function () {
            if (!('IntersectionObserver' in window)) {
                throw new LoaderError('Intersection observer is not supported');
            }
            if (!root.current) {
                return;
            }
            if (force) {
                return;
            }
            var observer = new IntersectionObserver(function (entries) { return __awaiter(_this, void 0, void 0, function () {
                var entries_1, entries_1_1, entry, e_1_1;
                var e_1, _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            _b.trys.push([0, 5, 6, 7]);
                            entries_1 = __values(entries), entries_1_1 = entries_1.next();
                            _b.label = 1;
                        case 1:
                            if (!!entries_1_1.done) return [3 /*break*/, 4];
                            entry = entries_1_1.value;
                            if (!entry.isIntersecting) {
                                return [2 /*return*/];
                            }
                            observer.disconnect();
                            return [4 /*yield*/, loadComponent()];
                        case 2:
                            _b.sent();
                            _b.label = 3;
                        case 3:
                            entries_1_1 = entries_1.next();
                            return [3 /*break*/, 1];
                        case 4: return [3 /*break*/, 7];
                        case 5:
                            e_1_1 = _b.sent();
                            e_1 = { error: e_1_1 };
                            return [3 /*break*/, 7];
                        case 6:
                            try {
                                if (entries_1_1 && !entries_1_1.done && (_a = entries_1.return)) _a.call(entries_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                            return [7 /*endfinally*/];
                        case 7: return [2 /*return*/];
                    }
                });
            }); }, __assign({ threshold: 0.1, rootMargin: '250px' }, intersectionObserverOptions));
            observer.observe(root.current);
            return function () {
                observer === null || observer === void 0 ? void 0 : observer.disconnect();
            };
        }, []);
        if (force) {
            (_a = Component.current) !== null && _a !== void 0 ? _a : (Component.current = lazy(function () {
                return load().then(function (mod) { return ({
                    default: interopDefault(mod),
                }); });
            }));
        }
        return Component.current !== undefined ? (_jsx(WithSuspense, __assign({ use: force, fallback: fallback }, { children: _jsx(Component.current, __assign({}, props)) }))) : (_jsx("div", __assign({}, placeholderProps, { dangerouslySetInnerHTML: { __html: '' }, suppressHydrationWarning: true, ref: root })));
    };
}
//# sourceMappingURL=intersection-loader.js.map